#include "font.hh"

struct mgr_font_header
{
    unsigned char type;      /* font type (magic number) '^v' */
    unsigned char wide;      /* character width (pixels) */
    unsigned char high;      /* char height (pixels) */
    unsigned char baseline;  /* pixels from bottom of glyph */
    unsigned char count;     /* number of chars in font */
    char start;              /* starting char in font */
};

int
Font::read_mgr_font(istream &input)
{
    struct mgr_font_header header;
    input.read(&header, sizeof(header));

    if (header.type != 026)
	return -1;

    if (encoding)
	delete encoding;

    n_chars = header.count;
    encoding = new short[n_chars];
    for (int i = 0; i < n_chars; i++)
	encoding[i] = header.start + i;

    if (glyph)
	delete glyph;
    glyph = new Glyph[n_chars];

    int byteswide = ((n_chars * header.wide - 1) / 32 + 1) * 4;
    unsigned char *bitmap = new unsigned char[byteswide * header.high];
    input.read(bitmap, byteswide * header.high);

    
	



    return 0;
}
