#ifndef FONT_HH
#define FONT_HH

#include <iostream.h>

class Glyph
{
  public:
    // Report total width and height (in pixels) of character box
    int get_width(void);
    int get_height(void);

    // Report offset of character origin in box
    int get_origin_x(void);
    int get_origin_y(void);

    // Read from MGR font file
    read_mgr(istream& input);

    // Dump ASCII representation
    write_ascii(ostream &output);

  protected:
    int width, height;
    int orgx, int orgy;
    unsigned char *bitmap;
};

class Font
{
  protected:
    int n_glyphs;
    short *encoding;
    Glyph *glyph;
};



#endif
